/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Paste and Go 2.
 *
 * The Initial Developer of the Original Code is Jens Bannmann.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s) (alphabetical order):
 *  Holio Lin <gaghiel@gmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
var pfOpenNewTab;
var pfBackground;
var group;
var current;
var fore;
var back;

var pfGoModifiers;
var pfSearchModifiers;
var gc;
var gs;
var ga;
var gm;
var gl;
var sc;
var ss;
var sa;
var sm;
var sl;

function onceLoad() {
    // tab behavior - declare
    pfOpenNewTab = document.getElementById('pgOpenNewTab');
    pfBackground = document.getElementById('pgBackgroundTab');
    
    group = document.getElementById('rgTabBehavior');
    current = document.getElementById('rdCurrent');
    fore = document.getElementById('rdNewFore');
    back = document.getElementById('rdNewBack');
    
    // tab behavior - init
    if (pfOpenNewTab.value) {
        if (pfBackground.value) {
            group.selectedItem = back;
        } else {
            group.selectedItem = fore;
        }
    } else {
        group.selectedItem = current;
    }
    
    // key - declare
    pfGoModifiers = document.getElementById('pgGoAccelKeys');
    pfSearchModifiers = document.getElementById('pgSearchAccelKeys');
    
    gc = document.getElementById('cbGoAccel-Ctrl');
    gs = document.getElementById('cbGoAccel-Shift');
    ga = document.getElementById('cbGoAccel-Alt');
    gm = document.getElementById('cbGoAccel-Meta');
    gl = document.getElementById('cbGoAccel-Accel');
    
    sc = document.getElementById('cbSearchAccel-Ctrl');
    ss = document.getElementById('cbSearchAccel-Shift');
    sa = document.getElementById('cbSearchAccel-Alt');
    sm = document.getElementById('cbSearchAccel-Meta');
    sl = document.getElementById('cbSearchAccel-Accel');

    // key - init
    if (pfGoModifiers.value.match('control'))
        gc.checked = true;
    if (pfGoModifiers.value.match('shift'))
        gs.checked = true;
    if (pfGoModifiers.value.match('alt'))
        ga.checked = true;
    if (pfGoModifiers.value.match('meta'))
        gm.checked = true;
    if (pfGoModifiers.value.match('accel'))
        gl.checked = true;
    
    if (pfSearchModifiers.value.match('control'))
        sc.checked = true;
    if (pfSearchModifiers.value.match('shift'))
        ss.checked = true;
    if (pfSearchModifiers.value.match('alt'))
        sa.checked = true;
    if (pfSearchModifiers.value.match('meta'))
        sm.checked = true;
    if (pfSearchModifiers.value.match('accel'))
        sl.checked = true;
}

function onceAccept() {
    // tab behavior - save
    if (current.selected)
        pfOpenNewTab.valueFromPreferences = false;
    else {
        pfOpenNewTab.valueFromPreferences = true;

        if (back.selected)
            pfBackground.valueFromPreferences = true;
        else // fore selected
            pfBackground.valueFromPreferences = false;
    }
    
    // key - save
    var tmp = "";
    if (gl.checked)
        tmp += 'accel ';
    if (gc.checked)
        tmp += 'control ';
    if (gs.checked)
        tmp += 'shift ';
    if (ga.checked)
        tmp += 'alt ';
    if (gm.checked)
        tmp += 'meta ';
    pfGoModifiers.valueFromPreferences = tmp;
    
    tmp = "";
    if (sl.checked)
        tmp += 'accel ';
    if (sc.checked)
        tmp += 'control ';
    if (ss.checked)
        tmp += 'shift ';
    if (sa.checked)
        tmp += 'alt ';
    if (sm.checked)
        tmp += 'meta ';
    pfSearchModifiers.valueFromPreferences = tmp;
}
